/***************************************************************************
 *   Copyright (C) 2006 by M.Fedotov   *
 *   anyremote@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef BT_COMM_H
#define BT_COMM_H

/**
	@author M.Fedotov <anyremote@mail.ru>
*/

#include <fcntl.h>
#include <termios.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <sys/time.h>
#include <errno.h>

#include <qstring.h>

const int WAIT_TIME 	= 1;
const int READ_TIMEOUT 	= 40;

class BtComm {
public:
	BtComm();
	~BtComm();

	bool initPort(QString& port);
	bool isConnected(void);
	void setConnected(bool);
	int closePort(int final);
	int getClip(QString& CallerID);
	int bt_readchar(char* c, int timeout); 
	int sendCommand(const QString cmd, QString& answer, QString expect);
	int sendSeq(const QString& seq);

	int openSocketPort(int type, int port); 
	int closeSocketPort();
	int listenAndAcceptSocketConn(int type);
	//int readSocketConn(QString& buffer);
	int writeSocketConn(QString& command);
	int writeBytesSocketConn(QString& command);
    
private:    

	int putCommand (QString command, QString& answer, int timeout, QString expect);   
	int readTmo    (char* buf, int len, int timeout);
	int sendCKPD	(const QString& key);
	QString parse_CLCC      (QString clcc);

	int oldflags;
	int portfd;
	int sportfd;
	int portflags;
	int rtscts;

	bool  Connected;
	int   style;

	struct termios oldterm;
	struct termios portterm;

	int useQuestionInCLCC;
};

#endif
